Package: shinystate
Title: Customization of Shiny Bookmarkable State
Version: 0.1.0
Authors@R: c(
    person(
      "Eric",
      "Nantz",
      email = "theRcast@gmail.com",
      role = c("aut", "cre"),
      comment = c(ORCID = '0000-0001-8104-7510')
    ),
    person(
      family = "Eli Lilly and Company",
      role = c("cph", "fnd")
    ))
Description: Enhance the bookmarkable state feature of 'shiny' with additional
    customization such as storage location and storage repositories leveraging
    the 'pins' package.
License: MIT + file LICENSE
Encoding: UTF-8
RoxygenNote: 7.3.2
Depends: R (>= 4.0.0)
Imports: archive, fs, htmltools, pins, R6, shiny (>= 0.14),
Suggests: bslib, DT, knitr, lubridate, rlang, rmarkdown,
        roxy.shinylive, testthat (>= 3.0.0), withr
Config/testthat/edition: 3
URL: https://rpodcast.github.io/shinystate/,
        https://github.com/rpodcast/shinystate
BugReports: https://github.com/rpodcast/shinystate/issues
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2025-09-13 02:34:20 UTC; eric
Author: Eric Nantz [aut, cre] (ORCID: <https://orcid.org/0000-0001-8104-7510>),
  Eli Lilly and Company [cph, fnd]
Maintainer: Eric Nantz <theRcast@gmail.com>
Repository: CRAN
Date/Publication: 2025-09-18 08:10:01 UTC
Built: R 4.6.0; ; 2026-04-28 21:19:09 UTC; unix

Package: shinystate
Title: Customization of Shiny Bookmarkable State
Version: 0.1.0
Authors@R: c(
    person(
      "Eric",
      "Nantz",
      email = "theRcast@gmail.com",
      role = c("aut", "cre"),
      comment = c(ORCID = '0000-0001-8104-7510')
    ),
    person(
      family = "Eli Lilly and Company",
      role = c("cph", "fnd")
    ))
Description: Enhance the bookmarkable state feature of 'shiny' with additional
    customization such as storage location and storage repositories leveraging
    the 'pins' package.
License: MIT + file LICENSE
Encoding: UTF-8
RoxygenNote: 7.3.2
Depends: R (>= 4.0.0)
Imports: archive, fs, htmltools, pins, R6, shiny (>= 0.14),
Suggests: bslib, DT, knitr, lubridate, rlang, rmarkdown,
        roxy.shinylive, testthat (>= 3.0.0), withr
Config/testthat/edition: 3
URL: https://rpodcast.github.io/shinystate/,
        https://github.com/rpodcast/shinystate
BugReports: https://github.com/rpodcast/shinystate/issues
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2025-09-13 02:34:20 UTC; eric
Author: Eric Nantz [aut, cre] (ORCID: <https://orcid.org/0000-0001-8104-7510>),
  Eli Lilly and Company [cph, fnd]
Maintainer: Eric Nantz <theRcast@gmail.com>
Repository: CRAN
Date/Publication: 2025-09-18 08:10:01 UTC
Built: R 4.6.0; ; 2026-04-26 15:10:01 UTC; unix

# shinystate <img src="man/figures/logo.png" align="right" height="139" alt="" />

<!-- badges: start -->
[![R-CMD-check](https://github.com/rpodcast/shinystate/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/rpodcast/shinystate/actions/workflows/R-CMD-check.yaml)
<!-- badges: end -->

`shinystate` is an R package that provides additional customization on top of the standard Shiny [bookmarkable state](https://shiny.posit.co/r/articles/share/bookmarking-state/) capabilities.

## Installation


```r
# Install the released version from CRAN
install.packages("shinystate")

# Or the development version from GitHub:
remotes::install_github("rpodcast/shinystate")
```

## Why `shinystate`?

If your Shiny application leverages bookmarkable state and the default feature set is working for your use case, then `shinystate` is likely not value-added. 

However, as applications grow in complexity and are used in high-stakes situations, you may wish your application could support the following features:

* Flexible configuration of where bookmarkable state files are stored, whether on the same file system as the server running the application, or in a separate repository such as cloud storage.
* Allow users to save multiple bookmarkable state sessions, tailored to situations such as multiple "projects" inside the same application.
* Augment the bookmarkable state artifacts with metadata of your choosing. Possible metadata could include custom names and timestamps.
 
The `shinystate` package offers an intuitive class system built upon the `R6` package with methods tailored to the common operations with managing bookmarkable state. 

## How to use it?

To enable saving bookmarkable state with `shinystate`, you need to:

1. Load the package: `library(shinystate)`
1. Create an instance of the `StorageClass` class outside of the application user interface and server functions: `StorageClass$new()`
1. Include `use_shinystate()` in your UI definition
1. Call the `register_metadata()` method from your instance of the `StorageClass` class at the beginning of the application server function
1. Enable the save-to-server bookmarking method by adding `enableBookmarking = 'server'` in the call to `shinyApp()`
1. Call the `snapshot()` method from your instance of the `StorageClass` class to save the state of the Shiny app session
1. Call the `restore()` method from your instance of the `StorageClass` class to restore a saved session based on the session URL, available in the data frame returned from the `get_sessions()` method.

Below is an example application illustrating the default usage of `shinystate`. Visit the [Getting Started](https://rpodcast.github.io/shinystate/articles/shinystate.html) for additional details.


```r
library(shiny)
library(bslib)
library(shinystate)

storage <- StorageClass$new()

ui <- function(request) {
  page_sidebar(
    title = "Basic App",
    sidebar = sidebar(
      accordion(
        open = TRUE,
        accordion_panel(
          id = "user_inputs",
          "User Inputs",
          textInput(
            "txt",
            label = "Enter Title",
            placeholder = "change this"
          ),
          checkboxInput("caps", "Capitalize"),
          sliderInput(
            "bins",
            label = "Number of bins",
            min = 1,
            max = 50,
            value = 30
          )
        ),
        accordion_panel(
          id = "state",
          "Bookmark State",
          actionButton("bookmark", "Bookmark"),
          actionButton("restore", "Restore Last Bookmark")
        )
      )
    ),
    use_shinystate(),
    card(
      card_header("App Output"),
      plotOutput("distPlot")
    )
  )
}

server <- function(input, output, session) {
  storage$register_metadata()

  plot_title <- reactive({
    if (!shiny::isTruthy(input$txt)) {
      value <- "Default Title"
    } else {
      value <- input$txt
    }

    if (input$caps) {
      value <- toupper(value)
    }

    return(value)
  })

  output$distPlot <- renderPlot({
    req(plot_title())
    x <- faithful$waiting
    bins <- seq(min(x), max(x), length.out = input$bins + 1)
    hist(
      x,
      breaks = bins,
      col = "#007bc2",
      border = "white",
      xlab = "Waiting time to next eruption (in mins)",
      main = plot_title()
    )
  })

  observeEvent(input$bookmark, {
    storage$snapshot()
    showNotification("Session successfully saved")
  })

  observeEvent(input$restore, {
    session_df <- storage$get_sessions()
    storage$restore(tail(session_df$url, n = 1))
  })

  setBookmarkExclude(c("add", "bookmark", "restore"))
}

shinyApp(ui, server, enableBookmarking = "server")
```

## Code of Conduct

Please note that the shinystate project is released with a [Contributor Code of Conduct](https://contributor-covenant.org/version/2/1/CODE_OF_CONDUCT.html). By contributing to this project, you agree to abide by its terms.

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----run-app-package, eval=FALSE----------------------------------------------
# library(shiny)
# library(shinystate)
# runExample("bookmark_module", package = "shinystate")

## ----shinylive_url, echo = FALSE, results = 'asis'----------------------------
code <- paste0(
  c(
    "webr::install('shinystate', repos = c('https://rpodcast.r-universe.dev', 'https://repo.r-wasm.org'))",
    knitr::knit_code$get("utils"),
    knitr::knit_code$get("bookmark-modules"),
    knitr::knit_code$get("filter-module"),
    knitr::knit_code$get("select-module"),
    knitr::knit_code$get("summarize-module"),
    knitr::knit_code$get("main-app")
  ),
  collapse = "\n"
)

url <- roxy.shinylive::create_shinylive_url(code)
cat(sprintf("[Open in Shinylive](%s)\n\n", url))

## ----shinylive_iframe, echo = FALSE, out.width = '150%', out.extra = 'style = "position: relative; z-index:1"', eval = knitr::is_html_output() && identical(Sys.getenv("IN_PKGDOWN"), "true")----
# knitr::include_url(url, height = "800px")

## ----main-app, eval=FALSE-----------------------------------------------------
# library(shiny)
# library(shinystate)
# library(dplyr)
# library(DT)
# library(rlang)
# library(lubridate)
# 
# #  recommended to define a directory for storage or a pins board
# storage <- StorageClass$new()
# 
# ui <- function(req) {
#   tagList(
#     # Bootstrap header
#     tags$header(
#       class = "navbar navbar-default navbar-static-top",
#       tags$div(
#         class = "container-fluid",
#         tags$div(
#           class = "navbar-header",
#           tags$div(class = "navbar-brand", "Bookmark Module Demo")
#         ),
#         # Links for restoring/loading sessions
#         tags$ul(
#           class = "nav navbar-nav navbar-right",
#           tags$li(
#             bookmark_modal_load_ui("bookmark")
#           ),
#           tags$li(
#             bookmark_modal_save_ui("bookmark")
#           )
#         )
#       )
#     ),
#     fluidPage(
#       use_shinystate(),
#       sidebarLayout(
#         position = "right",
#         column(
#           width = 4,
#           wellPanel(
#             select_vars_ui("select")
#           ),
#           wellPanel(
#             filter_ui("filter")
#           )
#         ),
#         mainPanel(
#           tabsetPanel(
#             id = "tabs",
#             tabPanel("Plot", tags$br(), plotOutput("plot", height = 600)),
#             tabPanel("Summary", tags$br(), verbatimTextOutput("summary")),
#             tabPanel("Table", tags$br(), tableOutput("table"))
#           )
#         )
#       )
#     )
#   )
# }
# 
# server <- function(input, output, session) {
#   callModule(bookmark_mod, "bookmark", storage)
#   storage$register_metadata()
#   datasetExpr <- reactive(expr(mtcars %>% mutate(cyl = factor(cyl))))
#   filterExpr <- callModule(filter_mod, "filter", datasetExpr)
#   selectExpr <- callModule(
#     select_vars,
#     "select",
#     reactive(names(eval_clean(datasetExpr()))),
#     filterExpr
#   )
# 
#   data <- reactive({
#     resultExpr <- selectExpr()
#     df <- eval_clean(resultExpr)
#     validate(need(nrow(df) > 0, "No data matches the filter"))
#     df
#   })
# 
#   output$table <- renderTable(
#     {
#       data()
#     },
#     rownames = TRUE
#   )
# 
#   do_plot <- function() {
#     plot(data())
#   }
# 
#   output$plot <- renderPlot({
#     do_plot()
#   })
# 
#   output$summary <- renderPrint({
#     summary(data())
#   })
# 
#   output$code <- renderText({
#     format_tidy_code(selectExpr())
#   })
# }
# 
# shinyApp(ui, server, onStart = function() {
#   shiny::enableBookmarking("server")
# })
# 

## ----bookmark-modules, eval=FALSE---------------------------------------------
# bookmark_modal_save_ui <- function(id) {
#   ns <- NS(id)
# 
#   tagList(
#     actionLink(ns("show_save_modal"), "Save session")
#   )
# }
# 
# bookmark_modal_load_ui <- function(id) {
#   ns <- NS(id)
# 
#   tagList(
#     actionLink(ns("show_load_modal"), "Restore session")
#   )
# }
# 
# bookmark_load_ui <- function(id) {
#   ns <- NS(id)
#   tagList(
#     uiOutput(ns("saved_sessions"))
#   )
# }
# 
# bookmark_mod <- function(input, output, session, storage) {
#   ns <- session$ns
#   session_df <- reactive({
#     storage$get_sessions()
#   })
# 
#   output$saved_sessions_placeholder <- renderUI({
#     DT::dataTableOutput(session$ns("saved_sessions_table"))
#   })
# 
#   output$saved_sessions_table <- DT::renderDataTable({
#     req(session_df())
#     DT::datatable(
#       session_df(),
#       escape = FALSE,
#       selection = "single"
#     )
#   })
# 
#   session_choice <- reactive({
#     req(session_df())
#     req(input$saved_sessions_table_rows_selected)
#     i <- input$saved_sessions_table_rows_selected
#     url <- session_df()[i, "url"]
#     return(url)
#   })
# 
#   observeEvent(input$restore, {
#     req(session_choice())
#     storage$restore(session_choice())
#   })
# 
#   shiny::setBookmarkExclude(c(
#     "show_save_modal",
#     "show_load_modal",
#     "save_name",
#     "save",
#     "session_choice",
#     "restore"
#   ))
# 
#   observeEvent(input$show_load_modal, {
#     showModal(modalDialog(
#       size = "xl",
#       easyClose = TRUE,
#       title = "Restore session",
#       footer = tagList(
#         modalButton("Cancel"),
#         actionButton(session$ns("restore"), "Restore", class = "btn-primary")
#       ),
#       tagList(
#         uiOutput(session$ns("saved_sessions_placeholder"))
#       )
#     ))
#   })
# 
#   observeEvent(input$show_save_modal, {
#     showModal(modalDialog(
#       easyClose = TRUE,
#       textInput(session$ns("save_name"), "Give this session a name"),
#       footer = tagList(
#         modalButton("Cancel"),
#         actionButton(session$ns("save"), "Save", class = "btn-primary")
#       )
#     ))
#   })
# 
#   observeEvent(input$save, ignoreInit = TRUE, {
#     tryCatch(
#       {
#         if (!isTruthy(input$save_name)) {
#           stop("Please specify a bookmark name")
#         } else {
#           removeModal()
#           storage$snapshot(
#             session_metadata = list(
#               save_name = input$save_name,
#               timestamp = Sys.time()
#             )
#           )
#           showNotification(
#             "Session successfully saved"
#           )
#         }
#       },
#       error = function(e) {
#         showNotification(
#           conditionMessage(e),
#           type = "error"
#         )
#       }
#     )
#   })
# }

## ----filter-module, eval=FALSE------------------------------------------------
# filter_ui <- function(id) {
#   ns <- NS(id)
# 
#   tagList(
#     div(id = ns("filter_container")),
#     actionButton(ns("show_filter_dialog_btn"), "Add filter")
#   )
# }
# 
# filter_mod <- function(input, output, session, data_expr) {
#   ns <- session$ns
# 
#   setBookmarkExclude(c("show_filter_dialog_btn", "add_filter_btn"))
# 
#   filter_fields <- list()
#   makeReactiveBinding("filter_fields")
# 
#   onBookmark(function(state) {
#     state$values$filter_field_names <- names(filter_fields)
#   })
# 
#   onRestore(function(state) {
#     filter_field_names <- state$values$filter_field_names
#     for (fieldname in filter_field_names) {
#       addFilter(fieldname)
#     }
#   })
# 
#   observeEvent(input$show_filter_dialog_btn, {
#     available_fields <- names(eval_clean(data_expr())) %>%
#       base::setdiff(names(filter_fields))
# 
#     showModal(modalDialog(
#       title = "Add filter",
# 
#       radioButtons(ns("filter_field"), "Field to filter", available_fields),
# 
#       footer = tagList(
#         modalButton("Cancel"),
#         actionButton(ns("add_filter_btn"), "Add filter")
#       )
#     ))
#   })
# 
#   observeEvent(input$add_filter_btn, {
#     addFilter(input$filter_field)
#     removeModal()
#   })
# 
#   addFilter <- function(fieldname) {
#     id <- paste0("filter__", fieldname)
# 
#     filter <- createFilter(
#       data = eval_clean(data_expr())[[fieldname]],
#       id = ns(id),
#       fieldname = fieldname
#     )
# 
#     freezeReactiveValue(input, id)
# 
#     insertUI(
#       paste0("#", ns("filter_container")),
#       "beforeEnd",
#       # TODO: escape special characters in fieldname
#       filter$ui
#     )
# 
#     filter$inputId <- id
#     filter_fields[[fieldname]] <<- filter
#   }
# 
#   reactive({
#     result_expr <- data_expr()
# 
#     if (length(filter_fields) == 0) {
#       return(result_expr)
#     }
# 
#     # Gather up all filter expressions
#     exprs <- lapply(names(filter_fields), function(name) {
#       filter <- filter_fields[[name]]
#       x <- as.symbol(name) #df[[name]]
#       param <- input[[filter[["inputId"]]]]
#       cond_expr <- filter[["filterExpr"]](x = x, param = param)
#       if (!is.null(cond_expr)) {
#         result_expr <<- expr(!!result_expr %>% filter(!!cond_expr))
#       }
#       invisible()
#     })
# 
#     result_expr
#   })
# }
# 
# createFilter <- function(data, id, fieldname) {
#   UseMethod("createFilter")
# }
# 
# createFilter.character <- function(data, id, fieldname) {
#   list(
#     ui = textInput(id, fieldname, ""),
#     filterExpr = function(x, param) {
#       if (!nzchar(param)) {
#         NULL
#       } else {
#         expr(grepl(!!param, !!x, ignore.case = TRUE, fixed = TRUE))
#       }
#     }
#   )
# }
# 
# createFilter.numeric <- function(data, id, fieldname) {
#   list(
#     ui = sliderInput(
#       id,
#       fieldname,
#       min = min(data),
#       max = max(data),
#       value = range(data)
#     ),
#     filterExpr = function(x, param) {
#       expr(!!x >= !!param[1] & !!x <= !!param[2])
#     }
#   )
# }
# 
# createFilter.integer <- createFilter.numeric
# 
# createFilter.factor <- function(data, id, fieldname) {
#   inputControl <- if (length(levels(data)) > 6) {
#     selectInput(id, fieldname, levels(data), character(0), multiple = TRUE)
#   } else {
#     checkboxGroupInput(id, fieldname, levels(data))
#   }
# 
#   list(
#     ui = inputControl,
#     filterExpr = function(x, param) {
#       if (length(param) == 0) {
#         NULL
#       } else {
#         expr(!!x %in% !!param)
#       }
#     }
#   )
# }
# 
# createFilter.POSIXt <- createFilter.numeric

## ----select-module, eval=FALSE------------------------------------------------
# select_vars_ui <- function(id) {
#   ns <- NS(id)
#   tagList(
#     uiOutput(ns("vars_ui"))
#   )
# }
# 
# select_vars <- function(input, output, session, vars, data_expr) {
#   ns <- session$ns
# 
#   output$vars_ui <- renderUI({
#     freezeReactiveValue(input, "vars")
#     selectInput(ns("vars"), "Variables to display", vars(), multiple = TRUE)
#     #checkboxGroupInput(ns("vars"), "Variables", names(data), selected = names(data))
#   })
# 
#   reactive({
#     if (length(input$vars) == 0) {
#       data_expr()
#     } else {
#       expr(!!data_expr() %>% select(!!!syms(input$vars)))
#     }
#   })
# }
# 

## ----summarize-module, eval=FALSE---------------------------------------------
# summarize_ui <- function(id) {
#   ns <- NS(id)
#   tagList(
#     uiOutput(ns("summarize_ui"))
#   )
# }
# 
# summarize_mod <- function(input, output, session, vars, data_expr) {
#   output$summarize_ui <- renderUI({
#     ns <- session$ns
# 
#     tagList(
#       selectInput(
#         ns("group_by"),
#         "Group by",
#         choices = vars(),
#         multiple = TRUE
#       ),
#       selectInput(
#         ns("operation"),
#         "Summary operation",
#         c("mean", "sum", "count")
#       ),
#       selectInput(
#         ns("aggregate"),
#         "Summary value",
#         choices = vars(),
#         multiple = TRUE
#       )
#     )
#   })
# 
#   reactive({
#     result_expr <- data_expr()
#     if (length(input$group_by) > 0) {
#       result_expr <- expr(!!result_expr %>% group_by(!!!syms(input$group_by)))
#     }
#     if (length(input$aggregate) > 0) {
#       op <- switch(
#         input$operation,
#         mean = quote(mean),
#         sum = quote(sum),
#         count = quote(length)
#       )
#       agg_exprs <- lapply(input$aggregate, function(var) {
#         col_name <- deparse(expr((!!sym(input$operation))(!!sym(var))))
#         expr(!!col_name := (!!op)(!!sym(var)))
#       })
#       result_expr <- expr(!!result_expr %>% summarise(!!!agg_exprs))
#     }
#     result_expr
#   })
# }

## ----utils, eval=FALSE--------------------------------------------------------
# #' Evaluate an expression in a fresh environment
# #'
# #' Like eval_tidy, but with different defaults. By default, instead of running
# #' in the caller's environment, it runs in a fresh environment.
# #' @export
# eval_clean <- function(expr, env = list(), enclos = clean_env()) {
#   eval_tidy(expr, env, enclos)
# }
# 
# #' Create a clean environment
# #'
# #' Creates a new environment whose parent is the global environment.
# #' @export
# clean_env <- function() {
#   new.env(parent = globalenv())
# }
# 
# #' Join calls into a pipeline
# expr_pipeline <- function(..., .list = list(...)) {
#   exprs <- .list
#   if (length(exprs) == 0) {
#     return(NULL)
#   }
# 
#   exprs <- rlang::flatten(exprs)
# 
#   exprs <- Filter(Negate(is.null), exprs)
# 
#   if (length(exprs) == 0) {
#     return(NULL)
#   }
# 
#   Reduce(
#     function(memo, expr) {
#       expr(!!memo %>% !!expr)
#     },
#     tail(exprs, -1),
#     exprs[[1]]
#   )
# }
# 
# friendly_time <- function(t) {
#   t <- round_date(t, "seconds")
#   now <- round_date(Sys.time(), "seconds")
# 
#   abs_day_diff <- abs(day(now) - day(t))
#   age <- now - t
# 
#   abs_age <- abs(age)
#   future <- age != abs_age
#   dir <- ifelse(future, "from now", "ago")
# 
#   format_rel <- function(singular, plural = paste0(singular, "s")) {
#     x <- as.integer(round(time_length(abs_age, singular)))
#     sprintf("%d %s %s", x, ifelse(x == 1, singular, plural), dir)
#   }
# 
#   ifelse(
#     abs_age == seconds(0),
#     "Now",
#     ifelse(
#       abs_age < minutes(1),
#       format_rel("second"),
#       ifelse(
#         abs_age < hours(1),
#         format_rel("minute"),
#         ifelse(
#           abs_age < hours(6),
#           format_rel("hour"),
#           # Less than 24 hours, and during the same calendar day
#           ifelse(
#             abs_age < days(1) & abs_day_diff == 0,
#             strftime(t, "%I:%M:%S %p"),
#             ifelse(
#               abs_age < days(3),
#               strftime(t, "%a %I:%M:%S %p"),
#               strftime(t, "%Y/%m/%d %I:%M:%S %p")
#             )
#           )
#         )
#       )
#     )
#   )
# }

library(shiny)
library(dplyr)
library(rlang)

filter_ui <- function(id) {
  ns <- NS(id)
  
  tagList(
    div(id = ns("filter_container")),
    actionButton(ns("show_filter_dialog_btn"), "Add filter")
  )
}

filter_mod <- function(input, output, session, data_expr) {
  ns <- session$ns
  
  setBookmarkExclude(c("show_filter_dialog_btn", "add_filter_btn"))
  
  filter_fields <- list()
  makeReactiveBinding("filter_fields")
  
  onBookmark(function(state) {
    state$values$filter_field_names <- names(filter_fields)
  })
  
  onRestore(function(state) {
    filter_field_names <- state$values$filter_field_names
    for (fieldname in filter_field_names) {
      addFilter(fieldname)
    }
  })
  
  observeEvent(input$show_filter_dialog_btn, {
    available_fields <- names(eval_clean(data_expr())) %>% base::setdiff(names(filter_fields))

    showModal(modalDialog(
      title = "Add filter",
      
      radioButtons(ns("filter_field"), "Field to filter",
        available_fields),
      
      footer = tagList(
        modalButton("Cancel"),
        actionButton(ns("add_filter_btn"), "Add filter")
      )
    ))
  })
  
  observeEvent(input$add_filter_btn, {
    addFilter(input$filter_field)
    removeModal()
  })
  
  addFilter <- function(fieldname) {
    id <- paste0("filter__", fieldname)
    
    filter <- createFilter(
      data = eval_clean(data_expr())[[fieldname]],
      id = ns(id),
      fieldname = fieldname)
    
    freezeReactiveValue(input, id)
    
    insertUI(
      paste0("#", ns("filter_container")),
      "beforeEnd",
      # TODO: escape special characters in fieldname
      filter$ui
    )

    filter$inputId <- id
    filter_fields[[fieldname]] <<- filter
  }
  
  reactive({
    result_expr <- data_expr()
    
    if (length(filter_fields) == 0) {
      return(result_expr)
    }
    
    # Gather up all filter expressions
    exprs <- lapply(names(filter_fields), function(name) {
      filter <- filter_fields[[name]]
      x <- as.symbol(name) #df[[name]]
      param <- input[[ filter[["inputId"]] ]]
      cond_expr <- filter[["filterExpr"]](x = x, param = param)
      if (!is.null(cond_expr)) {
        result_expr <<- expr(!!result_expr %>% filter(!!cond_expr))
      }
      invisible()
    })

    result_expr    
  })
}

createFilter <- function(data, id, fieldname) {
  UseMethod("createFilter")
}

createFilter.character <- function(data, id, fieldname) {
  list(
    ui = textInput(id, fieldname, ""),
    filterExpr = function(x, param) {
      if (!nzchar(param)) {
        NULL
      } else {
        expr(grepl(!!param, !!x, ignore.case = TRUE, fixed = TRUE))
      }
    }
  )
}

createFilter.numeric <- function(data, id, fieldname) {
  list(
    ui = sliderInput(id, fieldname, min = min(data), max = max(data),
      value = range(data)),
    filterExpr = function(x, param) {
      expr(!!x >= !!param[1] & !!x <= !!param[2])
    }
  )
}

createFilter.integer <- createFilter.numeric

createFilter.factor <- function(data, id, fieldname) {
  inputControl <- if (length(levels(data)) > 6) {
    selectInput(id, fieldname, levels(data), character(0), multiple = TRUE)
  } else {
    checkboxGroupInput(id, fieldname, levels(data))
  }
  
  list(
    ui = inputControl,
    filterExpr = function(x, param) {
      if (length(param) == 0)
        NULL
      else
        expr(!!x %in% !!param)
    }
  )
}

createFilter.POSIXt <- createFilter.numeric

library(shiny)
library(bslib)
library(shinystate)
library(R6)

# recommended to define a directory for storage or a pins board
storage <- StorageClass$new()

ui <- function(request) {
  page_sidebar(
    title = "Basic App",
    sidebar = sidebar(
      accordion(
        open = TRUE,
        accordion_panel(
          id = "user_inputs",
          "User Inputs",
          numericInput(
            "number",
            label = "Enter Number",
            value = 0,
            min = -9999,
            max = 9999
          ),
          actionButton("add", "Add")
        ),
        accordion_panel(
          id = "state",
          "Bookmark State",
          actionButton("bookmark", "Bookmark"),
          actionButton("restore", "Restore Last Bookmark")
        )
      )
    ),
    use_shinystate(),
    card(
      card_header("App Output"),
      uiOutput("current_sum")
    )
  )
}

server <- function(input, output, session) {
  storage$register_metadata()

  trigger <- reactiveVal(NULL)

  # R6 class to track sum
  Accumulator <- R6Class(
    "Accumulator",
    list(
      sum = 0,
      add = function(x = 1) {
        self$sum <- self$sum + x
        invisible(self)
      },
      serialize = function() {
        # Return a list with class definition and instance data
        list(
          class_name = "Accumulator",
          data = list(sum = self$sum),
          # Store the class definition as text
          class_def = deparse(substitute(Accumulator))
        )
      }
    )
  )

  # Add a static method to recreate from serialized data
  Accumulator$deserialize <- function(serialized_data) {
    instance <- Accumulator$new()
    instance$sum <- serialized_data$data$sum
    instance
  }

  x <- Accumulator$new()

  onBookmark(function(state) {
    message("entered onBookmark block!")
    serialized <- x$serialize()
    saveRDS(serialized, file.path(state$dir, "accumulator_serialized.rds"))
  })

  onRestored(function(state) {
    if (!is.null(state$dir)) {
      # read saved file
      if (file.exists(file.path(state$dir, "accumulator_serialized.rds"))) {
        loaded_data <- readRDS(file.path(
          state$dir,
          "accumulator_serialized.rds"
        ))
        x <<- Accumulator$deserialize(loaded_data)
        trigger(rnorm(1))
      }
    }
  })

  observeEvent(input$add, {
    x$add(input$number)
    trigger(rnorm(1))
  })

  output$current_sum <- renderUI({
    trigger()
    tags$p(paste0("The Current Sum is: ", x$sum))
  })

  observeEvent(input$bookmark, {
    serialized <- x$serialize()
    storage$snapshot()
    showNotification("Session successfully saved")
  })

  observeEvent(input$restore, {
    session_df <- storage$get_sessions()
    storage$restore(tail(session_df$url, n = 1))
  })

  setBookmarkExclude(c("add", "number", "bookmark", "restore"))
}

shinyApp(ui, server, onStart = function() {
  shiny::enableBookmarking("server")
})

## ----install-instructions, eval=FALSE-----------------------------------------
# install.packages("shinystate")

## ----app, eval=FALSE----------------------------------------------------------
# library(shiny)
# library(bslib)
# library(shinystate)
# 
# storage <- StorageClass$new()
# 
# ui <- function(request) {
#   page_sidebar(
#     title = "Basic App",
#     sidebar = sidebar(
#       accordion(
#         open = c("user_inputs", "state"),
#         accordion_panel(
#           id = "user_inputs",
#           "User Inputs",
#           textInput(
#             "txt",
#             label = "Enter Title",
#             placeholder = "change this"
#           ),
#           checkboxInput("caps", "Capitalize"),
#           sliderInput(
#             "bins",
#             label = "Number of bins",
#             min = 1,
#             max = 50,
#             value = 30
#           ),
#           actionButton("add", "Add")
#         ),
#         accordion_panel(
#           id = "state",
#           "Bookmark State",
#           actionButton("bookmark", "Bookmark"),
#           actionButton("restore", "Restore Last Bookmark")
#         )
#       )
#     ),
#     use_shinystate(),
#     card(
#       card_header("App Output"),
#       plotOutput("distPlot")
#     )
#   )
# }
# 
# server <- function(input, output, session) {
#   storage$register_metadata()
# 
#   vals <- reactiveValues(sum = 0)
# 
#   plot_title <- reactive({
#     if (!shiny::isTruthy(input$txt)) {
#       value <- "Default Title"
#     } else {
#       value <- input$txt
#     }
# 
#     if (input$caps) {
#       value <- toupper(value)
#     }
# 
#     return(value)
#   })
# 
#   onBookmark(function(state) {
#     state$values$currentSum <- vals$sum
#   })
# 
#   onRestore(function(state) {
#     vals$sum <- state$values$currentSum
#   })
# 
#   observeEvent(input$add, {
#     vals$sum <- vals$sum + input$n
#   })
# 
#   output$distPlot <- renderPlot({
#     req(plot_title())
#     x <- faithful$waiting
#     bins <- seq(min(x), max(x), length.out = input$bins + 1)
#     hist(
#       x,
#       breaks = bins,
#       col = "#007bc2",
#       border = "white",
#       xlab = "Waiting time to next eruption (in mins)",
#       main = plot_title()
#     )
#   })
# 
#   observeEvent(input$bookmark, {
#     storage$snapshot()
#     showNotification("Session successfully saved")
#   })
# 
#   observeEvent(input$restore, {
#     session_df <- storage$get_sessions()
#     storage$restore(tail(session_df$url, n = 1))
#   })
# 
#   setBookmarkExclude(c("add", "bookmark", "restore"))
# }
# 
# shinyApp(ui, server, enableBookmarking = "server")

## ----shinylive_url, echo = FALSE, results = 'asis'----------------------------
code <- paste0(
  c(
    "webr::install('shinystate', repos = c('https://rpodcast.r-universe.dev', 'https://repo.r-wasm.org'))",
    knitr::knit_code$get("app")
  ),
  collapse = "\n"
)

url <- roxy.shinylive::create_shinylive_url(code)
cat(sprintf("[Open in Shinylive](%s)\n\n", url))

## ----shinylive_iframe, echo = FALSE, out.width = '150%', out.extra = 'style = "position: relative; z-index:1"', eval = knitr::is_html_output() && identical(Sys.getenv("IN_PKGDOWN"), "true")----
# knitr::include_url(url, height = "800px")
# 

library(rlang)

#' Evaluate an expression in a fresh environment
#'
#' Like eval_tidy, but with different defaults. By default, instead of running
#' in the caller's environment, it runs in a fresh environment.
#' @export
eval_clean <- function(expr, env = list(), enclos = clean_env()) {
  eval_tidy(expr, env, enclos)
}

#' Create a clean environment
#'
#' Creates a new environment whose parent is the global environment.
#' @export
clean_env <- function() {
  new.env(parent = globalenv())
}

#' Join calls into a pipeline
expr_pipeline <- function(..., .list = list(...)) {
  exprs <- .list
  if (length(exprs) == 0) {
    return(NULL)
  }

  exprs <- rlang::flatten(exprs)

  exprs <- Filter(Negate(is.null), exprs)

  if (length(exprs) == 0) {
    return(NULL)
  }

  Reduce(
    function(memo, expr) {
      expr(!!memo %>% !!expr)
    },
    tail(exprs, -1),
    exprs[[1]]
  )
}

friendly_time <- function(t) {
  t <- round_date(t, "seconds")
  now <- round_date(Sys.time(), "seconds")

  abs_day_diff <- abs(day(now) - day(t))
  age <- now - t

  abs_age <- abs(age)
  future <- age != abs_age
  dir <- ifelse(future, "from now", "ago")

  format_rel <- function(singular, plural = paste0(singular, "s")) {
    x <- as.integer(round(time_length(abs_age, singular)))
    sprintf("%d %s %s", x, ifelse(x == 1, singular, plural), dir)
  }

  ifelse(
    abs_age == seconds(0),
    "Now",
    ifelse(
      abs_age < minutes(1),
      format_rel("second"),
      ifelse(
        abs_age < hours(1),
        format_rel("minute"),
        ifelse(
          abs_age < hours(6),
          format_rel("hour"),
          # Less than 24 hours, and during the same calendar day
          ifelse(
            abs_age < days(1) & abs_day_diff == 0,
            strftime(t, "%I:%M:%S %p"),
            ifelse(
              abs_age < days(3),
              strftime(t, "%a %I:%M:%S %p"),
              strftime(t, "%Y/%m/%d %I:%M:%S %p")
            )
          )
        )
      )
    )
  )
}

library(shiny)
library(bslib)
library(shinystate)

# recommended to define a directory for storage or a pins board
storage <- StorageClass$new()

ui <- function(request) {
  page_sidebar(
    title = "Basic App",
    sidebar = sidebar(
      accordion(
        open = TRUE,
        accordion_panel(
          id = "user_inputs",
          "User Inputs",
          textInput(
            "txt",
            label = "Enter Title",
            placeholder = "change this"
          ),
          checkboxInput("caps", "Capitalize"),
          sliderInput(
            "bins",
            label = "Number of bins",
            min = 1,
            max = 50,
            value = 30
          )
        ),
        accordion_panel(
          id = "state",
          "Bookmark State",
          actionButton("bookmark", "Bookmark"),
          actionButton("restore", "Restore Last Bookmark")
        )
      )
    ),
    use_shinystate(),
    card(
      card_header("App Output"),
      plotOutput("distPlot")
    )
  )
}

server <- function(input, output, session) {
  storage$register_metadata()

  plot_title <- reactive({
    if (!shiny::isTruthy(input$txt)) {
      value <- "Default Title"
    } else {
      value <- input$txt
    }

    if (input$caps) {
      value <- toupper(value)
    }

    return(value)
  })

  output$distPlot <- renderPlot({
    req(plot_title())
    x <- faithful$waiting
    bins <- seq(min(x), max(x), length.out = input$bins + 1)
    hist(
      x,
      breaks = bins,
      col = "#007bc2",
      border = "white",
      xlab = "Waiting time to next eruption (in mins)",
      main = plot_title()
    )
  })

  observeEvent(input$bookmark, {
    storage$snapshot()
    showNotification("Session successfully saved")
  })

  observeEvent(input$restore, {
    session_df <- storage$get_sessions()
    storage$restore(tail(session_df$url, n = 1))
  })

  setBookmarkExclude(c("add", "bookmark", "restore"))
}

shinyApp(ui, server, onStart = function() {
  shiny::enableBookmarking("server")
})

library(shiny)
library(dplyr)
library(rlang)

select_vars_ui <- function(id) {
  ns <- NS(id)
  tagList(
    uiOutput(ns("vars_ui"))
  )
}

select_vars <- function(input, output, session, vars, data_expr) {
  ns <- session$ns

  output$vars_ui <- renderUI({
    freezeReactiveValue(input, "vars")
    selectInput(ns("vars"), "Variables to display", vars(), multiple = TRUE)
    #checkboxGroupInput(ns("vars"), "Variables", names(data), selected = names(data))
  })
  
  reactive({
    if (length(input$vars) == 0) {
      data_expr()
    } else {
      expr(!!data_expr() %>% select(!!!syms(input$vars)))
    }
  })
}

library(shiny)
library(dplyr)
library(rlang)

summarize_ui <- function(id) {
  ns <- NS(id)
  tagList(
    uiOutput(ns("summarize_ui"))
  )
}

summarize_mod <- function(input, output, session, vars, data_expr) {
  output$summarize_ui <- renderUI({
    ns <- session$ns
    
    tagList(
      selectInput(ns("group_by"), "Group by", choices = vars(), multiple = TRUE),
      selectInput(ns("operation"), "Summary operation", c("mean", "sum", "count")),
      selectInput(ns("aggregate"), "Summary value", choices = vars(), multiple = TRUE)
    )
  })
  
  reactive({
    result_expr <- data_expr()
    if (length(input$group_by) > 0) {
      result_expr <- expr(!!result_expr %>% group_by(!!!syms(input$group_by)))
    }
    if (length(input$aggregate) > 0) {
      op <- switch(input$operation,
        mean = quote(mean),
        sum = quote(sum),
        count = quote(length)
      )
      agg_exprs <- lapply(input$aggregate, function(var) {
        col_name <- deparse(expr((!!sym(input$operation))(!!sym(var))))
        expr(!!col_name := (!!op)(!!sym(var)))
      })
      result_expr <- expr(!!result_expr %>% summarise(!!!agg_exprs))
    }
    result_expr
  })
}

library(shiny)
library(dplyr)
library(lubridate)

bookmark_modal_save_ui <- function(id) {
  ns <- NS(id)

  tagList(
    actionLink(ns("show_save_modal"), "Save session")
  )
}

bookmark_modal_load_ui <- function(id) {
  ns <- NS(id)

  tagList(
    actionLink(ns("show_load_modal"), "Restore session")
  )
}

bookmark_load_ui <- function(id) {
  ns <- NS(id)
  tagList(
    uiOutput(ns("saved_sessions"))
  )
}

bookmark_mod <- function(input, output, session, storage) {
  ns <- session$ns
  session_df <- reactive({
    storage$get_sessions()
  })

  output$saved_sessions_placeholder <- renderUI({
    DT::dataTableOutput(session$ns("saved_sessions_table"))
  })

  output$saved_sessions_table <- DT::renderDataTable({
    req(session_df())
    DT::datatable(
      session_df(),
      escape = FALSE,
      selection = "single"
    )
  })

  session_choice <- reactive({
    req(session_df())
    req(input$saved_sessions_table_rows_selected)
    i <- input$saved_sessions_table_rows_selected
    url <- session_df()[i, "url"]
    return(url)
  })

  observeEvent(input$restore, {
    req(session_choice())
    storage$restore(session_choice())
  })

  shiny::setBookmarkExclude(c(
    "show_save_modal",
    "show_load_modal",
    "save_name",
    "save",
    "session_choice",
    "restore"
  ))

  observeEvent(input$show_load_modal, {
    showModal(modalDialog(
      size = "xl",
      easyClose = TRUE,
      title = "Restore session",
      footer = tagList(
        modalButton("Cancel"),
        actionButton(session$ns("restore"), "Restore", class = "btn-primary")
      ),
      tagList(
        uiOutput(session$ns("saved_sessions_placeholder"))
      )
    ))
  })

  observeEvent(input$show_save_modal, {
    showModal(modalDialog(
      easyClose = TRUE,
      textInput(session$ns("save_name"), "Give this session a name"),
      footer = tagList(
        modalButton("Cancel"),
        actionButton(session$ns("save"), "Save", class = "btn-primary")
      )
    ))
  })

  observeEvent(input$save, ignoreInit = TRUE, {
    tryCatch(
      {
        if (!isTruthy(input$save_name)) {
          stop("Please specify a bookmark name")
        } else {
          removeModal()
          storage$snapshot(
            session_metadata = list(
              save_name = input$save_name,
              timestamp = Sys.time()
            )
          )
          showNotification(
            "Session successfully saved"
          )
        }
      },
      error = function(e) {
        showNotification(
          conditionMessage(e),
          type = "error"
        )
      }
    )
  })
}

library(shiny)
library(shinystate)
library(dplyr)
library(DT)

source("helpers/utils.R")
source("modules/select_module.R")
source("modules/filter_module.R")
source("modules/bookmark_module.R")
source("modules/summarize_module.R")

#  recommended to define a directory for storage or a pins board
storage <- StorageClass$new()

ui <- function(req) {
  tagList(
    # Bootstrap header
    tags$header(
      class = "navbar navbar-default navbar-static-top",
      tags$div(
        class = "container-fluid",
        tags$div(
          class = "navbar-header",
          tags$div(class = "navbar-brand", "Bookmark Module Demo")
        ),
        # Links for restoring/loading sessions
        tags$ul(
          class = "nav navbar-nav navbar-right",
          tags$li(
            bookmark_modal_load_ui("bookmark")
          ),
          tags$li(
            bookmark_modal_save_ui("bookmark")
          )
        )
      )
    ),
    fluidPage(
      use_shinystate(),
      sidebarLayout(
        position = "right",
        column(
          width = 4,
          wellPanel(
            select_vars_ui("select")
          ),
          wellPanel(
            filter_ui("filter")
          )
        ),
        mainPanel(
          tabsetPanel(
            id = "tabs",
            tabPanel("Plot", tags$br(), plotOutput("plot", height = 600)),
            tabPanel("Summary", tags$br(), verbatimTextOutput("summary")),
            tabPanel("Table", tags$br(), tableOutput("table"))
          )
        )
      )
    )
  )
}

server <- function(input, output, session) {
  callModule(bookmark_mod, "bookmark", storage)
  storage$register_metadata()
  datasetExpr <- reactive(expr(mtcars %>% mutate(cyl = factor(cyl))))
  filterExpr <- callModule(filter_mod, "filter", datasetExpr)
  selectExpr <- callModule(
    select_vars,
    "select",
    reactive(names(eval_clean(datasetExpr()))),
    filterExpr
  )

  data <- reactive({
    resultExpr <- selectExpr()
    df <- eval_clean(resultExpr)
    validate(need(nrow(df) > 0, "No data matches the filter"))
    df
  })

  output$table <- renderTable(
    {
      data()
    },
    rownames = TRUE
  )

  do_plot <- function() {
    plot(data())
  }

  output$plot <- renderPlot({
    do_plot()
  })

  output$summary <- renderPrint({
    summary(data())
  })

  output$code <- renderText({
    format_tidy_code(selectExpr())
  })
}

shinyApp(ui, server, onStart = function() {
  shiny::enableBookmarking("server")
})

---
title: "Bookmark Modules Example"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{bookmark-module}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

## Introduction

The `shinystate` package was greatly inspired by an [example application](https://github.com/jcheng5/rpharma-demo) created by Joe Cheng (creator of Shiny) to accompany his keynote presentation at the 2018 [R/Pharma conference](https://rinpharma.com/). Among other notable features as documented in the GitHub repository [README](https://github.com/jcheng5/rpharma-demo/blob/master/README.md), the application provided an alternative user interface powered by Shiny modules to save and restore bookmarkable state. The following example is an adaptation of the original version to utilize `shinystate` to manage the bookmarkable state features.

## How to Run Application

The application source code is included in the 'shinystate' package and it can be launched with the following code:

```{r run-app-package, eval=FALSE}
library(shiny)
library(shinystate)
runExample("bookmark_module", package = "shinystate")
```

If you are viewing this package vignette in a web browser, the application can also be viewed using the Shinylive service:

```{r shinylive_url, echo = FALSE, results = 'asis'}
code <- paste0(
  c(
    "webr::install('shinystate', repos = c('https://rpodcast.r-universe.dev', 'https://repo.r-wasm.org'))",
    knitr::knit_code$get("utils"),
    knitr::knit_code$get("bookmark-modules"),
    knitr::knit_code$get("filter-module"),
    knitr::knit_code$get("select-module"),
    knitr::knit_code$get("summarize-module"),
    knitr::knit_code$get("main-app")
  ),
  collapse = "\n"
)

url <- roxy.shinylive::create_shinylive_url(code)
cat(sprintf("[Open in Shinylive](%s)\n\n", url))
```

```{r shinylive_iframe, echo = FALSE, out.width = '150%', out.extra = 'style = "position: relative; z-index:1"', eval = knitr::is_html_output() && identical(Sys.getenv("IN_PKGDOWN"), "true")}
knitr::include_url(url, height = "800px")
```

## Application Code

The remainder of this vignette contains the source code of the application. Note that the version included in the package is constructed with separate R scripts containing the module and utility function code.

The same principles for using `shinystate` in an application apply in this example as well, but here are specific notes for the implementation used in this example application:

* The module `bookmark_mod` contains a parameter for the `StorageClass` instance used for the application.
* Bookmarkable state sessions are displayed using an interactive table produced by `DT::datatable()` with the ability to select the row used to restore a saved session. This is just one approach to display sessions in a Shiny application.
* A reactive object `session_choice` corresponding to the `url` value of the selected row in the sessions table is supplied to the `restore()` method of the `StorageClass` instance.
* Additional information corresponding to the session name entered in a text input as well as the current time are saved as part of the bookmarkable state snapshot metadata, assembled as a `list()` object with named elements for each variable.


### `app.R`

```{r main-app, eval=FALSE}
library(shiny)
library(shinystate)
library(dplyr)
library(DT)
library(rlang)
library(lubridate)

#  recommended to define a directory for storage or a pins board
storage <- StorageClass$new()

ui <- function(req) {
  tagList(
    # Bootstrap header
    tags$header(
      class = "navbar navbar-default navbar-static-top",
      tags$div(
        class = "container-fluid",
        tags$div(
          class = "navbar-header",
          tags$div(class = "navbar-brand", "Bookmark Module Demo")
        ),
        # Links for restoring/loading sessions
        tags$ul(
          class = "nav navbar-nav navbar-right",
          tags$li(
            bookmark_modal_load_ui("bookmark")
          ),
          tags$li(
            bookmark_modal_save_ui("bookmark")
          )
        )
      )
    ),
    fluidPage(
      use_shinystate(),
      sidebarLayout(
        position = "right",
        column(
          width = 4,
          wellPanel(
            select_vars_ui("select")
          ),
          wellPanel(
            filter_ui("filter")
          )
        ),
        mainPanel(
          tabsetPanel(
            id = "tabs",
            tabPanel("Plot", tags$br(), plotOutput("plot", height = 600)),
            tabPanel("Summary", tags$br(), verbatimTextOutput("summary")),
            tabPanel("Table", tags$br(), tableOutput("table"))
          )
        )
      )
    )
  )
}

server <- function(input, output, session) {
  callModule(bookmark_mod, "bookmark", storage)
  storage$register_metadata()
  datasetExpr <- reactive(expr(mtcars %>% mutate(cyl = factor(cyl))))
  filterExpr <- callModule(filter_mod, "filter", datasetExpr)
  selectExpr <- callModule(
    select_vars,
    "select",
    reactive(names(eval_clean(datasetExpr()))),
    filterExpr
  )

  data <- reactive({
    resultExpr <- selectExpr()
    df <- eval_clean(resultExpr)
    validate(need(nrow(df) > 0, "No data matches the filter"))
    df
  })

  output$table <- renderTable(
    {
      data()
    },
    rownames = TRUE
  )

  do_plot <- function() {
    plot(data())
  }

  output$plot <- renderPlot({
    do_plot()
  })

  output$summary <- renderPrint({
    summary(data())
  })

  output$code <- renderText({
    format_tidy_code(selectExpr())
  })
}

shinyApp(ui, server, onStart = function() {
  shiny::enableBookmarking("server")
})

```

### `bookmark_modules.R`

```{r bookmark-modules, eval=FALSE}
bookmark_modal_save_ui <- function(id) {
  ns <- NS(id)

  tagList(
    actionLink(ns("show_save_modal"), "Save session")
  )
}

bookmark_modal_load_ui <- function(id) {
  ns <- NS(id)

  tagList(
    actionLink(ns("show_load_modal"), "Restore session")
  )
}

bookmark_load_ui <- function(id) {
  ns <- NS(id)
  tagList(
    uiOutput(ns("saved_sessions"))
  )
}

bookmark_mod <- function(input, output, session, storage) {
  ns <- session$ns
  session_df <- reactive({
    storage$get_sessions()
  })

  output$saved_sessions_placeholder <- renderUI({
    DT::dataTableOutput(session$ns("saved_sessions_table"))
  })

  output$saved_sessions_table <- DT::renderDataTable({
    req(session_df())
    DT::datatable(
      session_df(),
      escape = FALSE,
      selection = "single"
    )
  })

  session_choice <- reactive({
    req(session_df())
    req(input$saved_sessions_table_rows_selected)
    i <- input$saved_sessions_table_rows_selected
    url <- session_df()[i, "url"]
    return(url)
  })

  observeEvent(input$restore, {
    req(session_choice())
    storage$restore(session_choice())
  })

  shiny::setBookmarkExclude(c(
    "show_save_modal",
    "show_load_modal",
    "save_name",
    "save",
    "session_choice",
    "restore"
  ))

  observeEvent(input$show_load_modal, {
    showModal(modalDialog(
      size = "xl",
      easyClose = TRUE,
      title = "Restore session",
      footer = tagList(
        modalButton("Cancel"),
        actionButton(session$ns("restore"), "Restore", class = "btn-primary")
      ),
      tagList(
        uiOutput(session$ns("saved_sessions_placeholder"))
      )
    ))
  })

  observeEvent(input$show_save_modal, {
    showModal(modalDialog(
      easyClose = TRUE,
      textInput(session$ns("save_name"), "Give this session a name"),
      footer = tagList(
        modalButton("Cancel"),
        actionButton(session$ns("save"), "Save", class = "btn-primary")
      )
    ))
  })

  observeEvent(input$save, ignoreInit = TRUE, {
    tryCatch(
      {
        if (!isTruthy(input$save_name)) {
          stop("Please specify a bookmark name")
        } else {
          removeModal()
          storage$snapshot(
            session_metadata = list(
              save_name = input$save_name,
              timestamp = Sys.time()
            )
          )
          showNotification(
            "Session successfully saved"
          )
        }
      },
      error = function(e) {
        showNotification(
          conditionMessage(e),
          type = "error"
        )
      }
    )
  })
}
```

### `filter_module.R`

```{r filter-module, eval=FALSE}
filter_ui <- function(id) {
  ns <- NS(id)

  tagList(
    div(id = ns("filter_container")),
    actionButton(ns("show_filter_dialog_btn"), "Add filter")
  )
}

filter_mod <- function(input, output, session, data_expr) {
  ns <- session$ns

  setBookmarkExclude(c("show_filter_dialog_btn", "add_filter_btn"))

  filter_fields <- list()
  makeReactiveBinding("filter_fields")

  onBookmark(function(state) {
    state$values$filter_field_names <- names(filter_fields)
  })

  onRestore(function(state) {
    filter_field_names <- state$values$filter_field_names
    for (fieldname in filter_field_names) {
      addFilter(fieldname)
    }
  })

  observeEvent(input$show_filter_dialog_btn, {
    available_fields <- names(eval_clean(data_expr())) %>%
      base::setdiff(names(filter_fields))

    showModal(modalDialog(
      title = "Add filter",

      radioButtons(ns("filter_field"), "Field to filter", available_fields),

      footer = tagList(
        modalButton("Cancel"),
        actionButton(ns("add_filter_btn"), "Add filter")
      )
    ))
  })

  observeEvent(input$add_filter_btn, {
    addFilter(input$filter_field)
    removeModal()
  })

  addFilter <- function(fieldname) {
    id <- paste0("filter__", fieldname)

    filter <- createFilter(
      data = eval_clean(data_expr())[[fieldname]],
      id = ns(id),
      fieldname = fieldname
    )

    freezeReactiveValue(input, id)

    insertUI(
      paste0("#", ns("filter_container")),
      "beforeEnd",
      # TODO: escape special characters in fieldname
      filter$ui
    )

    filter$inputId <- id
    filter_fields[[fieldname]] <<- filter
  }

  reactive({
    result_expr <- data_expr()

    if (length(filter_fields) == 0) {
      return(result_expr)
    }

    # Gather up all filter expressions
    exprs <- lapply(names(filter_fields), function(name) {
      filter <- filter_fields[[name]]
      x <- as.symbol(name) #df[[name]]
      param <- input[[filter[["inputId"]]]]
      cond_expr <- filter[["filterExpr"]](x = x, param = param)
      if (!is.null(cond_expr)) {
        result_expr <<- expr(!!result_expr %>% filter(!!cond_expr))
      }
      invisible()
    })

    result_expr
  })
}

createFilter <- function(data, id, fieldname) {
  UseMethod("createFilter")
}

createFilter.character <- function(data, id, fieldname) {
  list(
    ui = textInput(id, fieldname, ""),
    filterExpr = function(x, param) {
      if (!nzchar(param)) {
        NULL
      } else {
        expr(grepl(!!param, !!x, ignore.case = TRUE, fixed = TRUE))
      }
    }
  )
}

createFilter.numeric <- function(data, id, fieldname) {
  list(
    ui = sliderInput(
      id,
      fieldname,
      min = min(data),
      max = max(data),
      value = range(data)
    ),
    filterExpr = function(x, param) {
      expr(!!x >= !!param[1] & !!x <= !!param[2])
    }
  )
}

createFilter.integer <- createFilter.numeric

createFilter.factor <- function(data, id, fieldname) {
  inputControl <- if (length(levels(data)) > 6) {
    selectInput(id, fieldname, levels(data), character(0), multiple = TRUE)
  } else {
    checkboxGroupInput(id, fieldname, levels(data))
  }

  list(
    ui = inputControl,
    filterExpr = function(x, param) {
      if (length(param) == 0) {
        NULL
      } else {
        expr(!!x %in% !!param)
      }
    }
  )
}

createFilter.POSIXt <- createFilter.numeric
```

### `select_module.R`

```{r select-module, eval=FALSE}
select_vars_ui <- function(id) {
  ns <- NS(id)
  tagList(
    uiOutput(ns("vars_ui"))
  )
}

select_vars <- function(input, output, session, vars, data_expr) {
  ns <- session$ns

  output$vars_ui <- renderUI({
    freezeReactiveValue(input, "vars")
    selectInput(ns("vars"), "Variables to display", vars(), multiple = TRUE)
    #checkboxGroupInput(ns("vars"), "Variables", names(data), selected = names(data))
  })

  reactive({
    if (length(input$vars) == 0) {
      data_expr()
    } else {
      expr(!!data_expr() %>% select(!!!syms(input$vars)))
    }
  })
}

```

### `summarize_module.R`

```{r summarize-module, eval=FALSE}
summarize_ui <- function(id) {
  ns <- NS(id)
  tagList(
    uiOutput(ns("summarize_ui"))
  )
}

summarize_mod <- function(input, output, session, vars, data_expr) {
  output$summarize_ui <- renderUI({
    ns <- session$ns

    tagList(
      selectInput(
        ns("group_by"),
        "Group by",
        choices = vars(),
        multiple = TRUE
      ),
      selectInput(
        ns("operation"),
        "Summary operation",
        c("mean", "sum", "count")
      ),
      selectInput(
        ns("aggregate"),
        "Summary value",
        choices = vars(),
        multiple = TRUE
      )
    )
  })

  reactive({
    result_expr <- data_expr()
    if (length(input$group_by) > 0) {
      result_expr <- expr(!!result_expr %>% group_by(!!!syms(input$group_by)))
    }
    if (length(input$aggregate) > 0) {
      op <- switch(
        input$operation,
        mean = quote(mean),
        sum = quote(sum),
        count = quote(length)
      )
      agg_exprs <- lapply(input$aggregate, function(var) {
        col_name <- deparse(expr((!!sym(input$operation))(!!sym(var))))
        expr(!!col_name := (!!op)(!!sym(var)))
      })
      result_expr <- expr(!!result_expr %>% summarise(!!!agg_exprs))
    }
    result_expr
  })
}
```

### `utils.R`

```{r utils, eval=FALSE}
#' Evaluate an expression in a fresh environment
#'
#' Like eval_tidy, but with different defaults. By default, instead of running
#' in the caller's environment, it runs in a fresh environment.
#' @export
eval_clean <- function(expr, env = list(), enclos = clean_env()) {
  eval_tidy(expr, env, enclos)
}

#' Create a clean environment
#'
#' Creates a new environment whose parent is the global environment.
#' @export
clean_env <- function() {
  new.env(parent = globalenv())
}

#' Join calls into a pipeline
expr_pipeline <- function(..., .list = list(...)) {
  exprs <- .list
  if (length(exprs) == 0) {
    return(NULL)
  }

  exprs <- rlang::flatten(exprs)

  exprs <- Filter(Negate(is.null), exprs)

  if (length(exprs) == 0) {
    return(NULL)
  }

  Reduce(
    function(memo, expr) {
      expr(!!memo %>% !!expr)
    },
    tail(exprs, -1),
    exprs[[1]]
  )
}

friendly_time <- function(t) {
  t <- round_date(t, "seconds")
  now <- round_date(Sys.time(), "seconds")

  abs_day_diff <- abs(day(now) - day(t))
  age <- now - t

  abs_age <- abs(age)
  future <- age != abs_age
  dir <- ifelse(future, "from now", "ago")

  format_rel <- function(singular, plural = paste0(singular, "s")) {
    x <- as.integer(round(time_length(abs_age, singular)))
    sprintf("%d %s %s", x, ifelse(x == 1, singular, plural), dir)
  }

  ifelse(
    abs_age == seconds(0),
    "Now",
    ifelse(
      abs_age < minutes(1),
      format_rel("second"),
      ifelse(
        abs_age < hours(1),
        format_rel("minute"),
        ifelse(
          abs_age < hours(6),
          format_rel("hour"),
          # Less than 24 hours, and during the same calendar day
          ifelse(
            abs_age < days(1) & abs_day_diff == 0,
            strftime(t, "%I:%M:%S %p"),
            ifelse(
              abs_age < days(3),
              strftime(t, "%a %I:%M:%S %p"),
              strftime(t, "%Y/%m/%d %I:%M:%S %p")
            )
          )
        )
      )
    )
  )
}
```

---
title: "shinystate"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{shinystate}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

## Introduction

`shinystate` is an R package that enables Shiny application developers to customize key features of [bookmarkable state](https://shiny.posit.co/r/articles/share/bookmarking-state/). The bookmarkable state feature included in `shiny` lets an application user save the state of the application (such as the values of inputs), in which the state can either be encoded in a custom URL or saved as objects to a hosting server. For a standard Shiny application with a small number of input controls, the built-in bookmarkable state features will likely suffice. However, a handful of limitations exist for intermediate or complex applications:

* Encoding a large number of input settings using the URL method may reach or surpass the allowable length of a URL in web browsers.
* Saving bookmarkable state to a server requires a compatible hosting platform (such as Posit Connect or Shiny Server Pro). Even with those hosting providers, the bookmarkable state session files are saved to directories in the hosting server only accessible by system accounts, and not easily shared between users.

Shiny includes the ability to augment bookmarkable state with callback functions as discussed in the [advanced bookmarking](https://shiny.posit.co/r/articles/share/advanced-bookmarking/) article, intended to assist with applications involving a complex reactive structure alongside user inputs. On the surface, these callbacks appear to address different issues than the aforementioned limitations. In the inagural R/Pharma conference held in 2018, Joe Cheng shared a [Shiny application](https://github.com/jcheng5/rpharma-demo) demonstrating small enhancements to managing multiple bookmarkable state sessions for the current user in a development context. The `shinystate` package incorporates novel approaches to offer Shiny developers an intuitive framework to address these limitations:

* Integrate with the`pins` package to offer multiple storage locations to save bookmarkable state files.
* Add optional metadata to compliment the existing bookmarkable state objects as the time a snapshot is created.
* Perform bookmarkable state operations using a new `R6` class called `StorageClass`.

## Installation

The [shinystate](https://rpodcast.github.io/shinystate/) package can be installed from CRAN:

```{r install-instructions, eval=FALSE}
install.packages("shinystate")
```

## Usage

To enable saving bookmarkable state with `shinystate`, you need to:

1. Load the package: `library(shinystate)`
1. Create an instance of the `StorageClass` class outside of the application user interface and server functions: `StorageClass$new()`
1. Include `use_shinystate()` in your UI definition
1. Call the `register_metadata()` method from your instance of the `StorageClass` class at the beginning of the application server function
1. Enable the save-to-server bookmarking method by adding `enableBookmarking = 'server'` in the call to `shinyApp()`
1. Call the `snapshot()` method from your instance of the `StorageClass` class to save the state of the Shiny app session
1. Call the `restore()` method from your instance of the `StorageClass` class to restore a saved session based on the session URL, available in the data frame returned from the `get_sessions()` method.

## Example Application

Below is an example application illustrating the default usage of `shinystate`. The application has a small set of user inputs as well as a reactive value that will also be saved as part of the bookmarkable state session. A pair of action buttons trigger the saving and loading of bookmarkable state within their respective `observeEvent` expressions. In this application, the most recent bookmarkable state session is restored by obtaining the last record's URL value in the session data frame.

```{r app, eval=FALSE}
library(shiny)
library(bslib)
library(shinystate)

storage <- StorageClass$new()

ui <- function(request) {
  page_sidebar(
    title = "Basic App",
    sidebar = sidebar(
      accordion(
        open = c("user_inputs", "state"),
        accordion_panel(
          id = "user_inputs",
          "User Inputs",
          textInput(
            "txt",
            label = "Enter Title",
            placeholder = "change this"
          ),
          checkboxInput("caps", "Capitalize"),
          sliderInput(
            "bins",
            label = "Number of bins",
            min = 1,
            max = 50,
            value = 30
          ),
          actionButton("add", "Add")
        ),
        accordion_panel(
          id = "state",
          "Bookmark State",
          actionButton("bookmark", "Bookmark"),
          actionButton("restore", "Restore Last Bookmark")
        )
      )
    ),
    use_shinystate(),
    card(
      card_header("App Output"),
      plotOutput("distPlot")
    )
  )
}

server <- function(input, output, session) {
  storage$register_metadata()

  vals <- reactiveValues(sum = 0)

  plot_title <- reactive({
    if (!shiny::isTruthy(input$txt)) {
      value <- "Default Title"
    } else {
      value <- input$txt
    }

    if (input$caps) {
      value <- toupper(value)
    }

    return(value)
  })

  onBookmark(function(state) {
    state$values$currentSum <- vals$sum
  })

  onRestore(function(state) {
    vals$sum <- state$values$currentSum
  })

  observeEvent(input$add, {
    vals$sum <- vals$sum + input$n
  })

  output$distPlot <- renderPlot({
    req(plot_title())
    x <- faithful$waiting
    bins <- seq(min(x), max(x), length.out = input$bins + 1)
    hist(
      x,
      breaks = bins,
      col = "#007bc2",
      border = "white",
      xlab = "Waiting time to next eruption (in mins)",
      main = plot_title()
    )
  })

  observeEvent(input$bookmark, {
    storage$snapshot()
    showNotification("Session successfully saved")
  })

  observeEvent(input$restore, {
    session_df <- storage$get_sessions()
    storage$restore(tail(session_df$url, n = 1))
  })

  setBookmarkExclude(c("add", "bookmark", "restore"))
}

shinyApp(ui, server, enableBookmarking = "server")
```

### Try it out in Shinylive

```{r shinylive_url, echo = FALSE, results = 'asis'}
code <- paste0(
  c(
    "webr::install('shinystate', repos = c('https://rpodcast.r-universe.dev', 'https://repo.r-wasm.org'))",
    knitr::knit_code$get("app")
  ),
  collapse = "\n"
)

url <- roxy.shinylive::create_shinylive_url(code)
cat(sprintf("[Open in Shinylive](%s)\n\n", url))
```

```{r shinylive_iframe, echo = FALSE, out.width = '150%', out.extra = 'style = "position: relative; z-index:1"', eval = knitr::is_html_output() && identical(Sys.getenv("IN_PKGDOWN"), "true")}
knitr::include_url(url, height = "800px")
